package comp3804a2;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class BookPacker {

    public double computeMaximumEnjoyment(List<Book> books, int weightLimit, int minFromEachGenre) {
        // TODO: Implement
        return 0;
    }

    public List<Book> computeMaximumEnjoymentBooks(List<Book> books, int weightLimit, int minFromEachGenre) {
        // BONUS: Implement
        return Collections.emptyList();
    }

    public static void main(String[] args) {
        // This performs a small test
        System.out.print("Testing basic correctness: ");

        BookPacker packer = new BookPacker();
        List<Book> books = new ArrayList<>(Arrays.asList(new Book(1, 1, Book.Genre.CLASSICS), new Book(1, 1, Book.Genre.FANTASY), new Book(1, 1, Book.Genre.SCIENCE_FICTION), new Book(3, 5, Book.Genre.FANTASY)));

        if (packer.computeMaximumEnjoyment(books, 3, 1) != 3
                || packer.computeMaximumEnjoyment(books, 3, 0) != 5) {
            System.out.println("BookPacker is incorrect!");
        } else {
            System.out.println("Everything seems fine so far.");

            System.out.println(" (Bonus) Best books without restrictions:   " + packer.computeMaximumEnjoymentBooks(books, 3, 0));
            System.out.println(" (Bonus) Best books with 1 from each genre: " + packer.computeMaximumEnjoymentBooks(books, 3, 1));
        }

        System.out.println("Testing basic efficiency: this should take less than a second...");
        long start = System.currentTimeMillis();

        for (int i = 0; i < 20; i++) {
            books.add(new Book(i, Math.sqrt(i), Book.Genre.values()[i % 3]));
        }

        for (int i = 0; i < 80; i++) {
            packer.computeMaximumEnjoyment(books, i, i / 20);
        }

        System.out.println("Done. That took " + ((System.currentTimeMillis() - start) / 1000.0) + " seconds.");
    }
}
